#ifndef __STACK__H__
#define __STACK__H__

typedef struct stack
  {
  int val;
  char *str;
  struct stack *prev;
  } stack_element;

typedef stack_element * stack_id;

int stack_push( stack_id *, int, char *);
int stack_pop( stack_id *, int *, char *);
int stack_find( stack_id *, int *, char *, int);

#define OK                      0
#define ALLOCATION_ERROR        1
#define EMPTY_STACK             2
#define NOT_FOUND		3
#define IGNORE_CASE 0
#define HOLD_CASE !(IGNORE_CASE)

#endif
